<template>
    <div
        class="page-container"
    >
        <ValidationObserver
            ref="form"
        >
            <div class="edit__top">
                <div class="campaigns-title">
                    Edit Campaign
                </div>
                <div
                    class="d-flex flex-column align-items-end"
                    style="margin-left: auto"
                >
                    <add-credits
                        v-if="platform === 'wix'"
                        class="d-inline-block"
                    />
                    <Buttons
                        custom-class="edit__actions"
                        :items="btns"
                        @deleteCampaign="cancel"
                        @openPreviewPopup="openPreviewPopup"
                        @saveDraftTrue="submit(true)"
                        @saveDraftFalse="submit(false)"
                    />
                </div>
            </div>
            <div
                v-if="!loading"
                class="content row"
            >
                <div class="col-lg-12 col-xl-6">
                    <SmsCampaignForm
                        :data="data"
                        :count-of-messages="countOfMessages"
                        @checkChanged="checkChanged"
                    />
                    <SmsCampaignSchedule
                        :data="data"
                        :old-data="oldData"
                        @checkChanged="checkChanged"
                    />
                    <pricing-data
                        :count-of-messages="countOfMessages"
                        @getPriceData="setPriceData"
                    />
                </div>
                <div class="col-lg-12 col-xl-6 edit__preview">
                    <SmsPhonePreview
                        :body-text="data.body_text"
                        :unsubscribe-text="data.unsubscribe_text"
                        :automatic-discount-enabled="data.automatic_discount_enabled"
                        :automatic-discount-value="data.automatic_discount_value"
                        :discount-code="data.discount_code"
                    />
                </div>
            </div>
        </ValidationObserver>
        <NoCreditPopup
            :show="noCreditsPopup"
            :price-data="priceData"
            @open="noCreditsPopup = $event"
            @close="noCreditsPopup = false"
            @submit="submit($event.isDraft, $event.useExistingCredits)"
        />
        <SendTest
            v-if="previewPopup"
            ref="test"
            type="phone"
            :show-text="showAlertText"
            :show-text-notification="showMaxPriceNotification"
            @send="sendPreview"
            @close="previewPopup = false"
        >
            <template #unsaved>
                You have unsaved changes. We will send the last saved version of the message.
            </template>
            <template #notification>
                Heads up! The cost of this test SMS is higher than the maximum SMS price that you defined. You can send it anyway. To update maximum SMS price navigate to the Settings page.
            </template>
        </SendTest>
        <DisabledCountriesModal
            v-if="sendData && showDisabledCountriesModal"
            ref="disabled_countries_modal"
            :show="showDisabledCountriesModal"
            :countries="sendData.disabledCountries"
            @confirm="sendPreview({smsValue: sendData.smsValue, averagePrice: sendData.averagePrice})"
            @close="closeDisabledCountriesModal"
        />
    </div>
</template>

<script>
import SmsCampaignForm from "@/components/sms/campaigns/SmsCampaignForm";
import SmsCampaignSchedule from "@/components/sms/campaigns/SmsCampaignSchedule";
import SmsPhonePreview from "@/components/sms/SmsPhonePreview";
import AddCredits from "@/components/pricing/AddCredits";
import PricingData from "@/components/sms/campaigns/PricingData";
import NoCreditPopup from '@/components/sms/campaigns/NoCreditPopup.vue';
import smsCampaign from '@/mixins/sms/campaigns.service';
import shop from '@/mixins/shop.service';
import pricing from '@/mixins/pricing/pricing.service'
import {tags} from "@/mixins/add-tags"
import {mapState} from 'vuex'
import SendTest from "@/components/modals/SendTest"
import DisabledCountriesModal from '@/components/sms/DisabledCountriesModal'
import {SegmentedMessage} from 'sms-segments-calculator'

export default {
    components: {PricingData, AddCredits, SmsPhonePreview, SmsCampaignForm, SmsCampaignSchedule, NoCreditPopup, SendTest, DisabledCountriesModal},
    mixins: [smsCampaign, shop, pricing, tags],
    props: {
        title: {
            type: String,
            default: "Edit"
        },
    },
    data() {
        return {
            loading: true,
            data: {
                automatic_discount_enabled: true,
                automatic_discount_value: 10,
                body_text: '',
                unsubscribe_text: 'Unsubscribe:',
                is_draft: true,
                use_subscriber_timezone: false,
                unsubscribe_confirmation: 'You have been successfully unsubscribed',
            },
            edited: null,
            oldData: null,
            isDraft: true,
            previewPopup: false,
            smsValue: [],
            averagePrice: "",
            country: '',
            allWorld: false,
            showAlertText: false,
            showMaxPriceNotification: false,
            showDisabledCountriesModal: false,
            sendData: null,
            disabledLaunch: false,
            priceData: {
                approximate_sms_campaign_cost: 0,
            },
            balance: {
                smsBalance: 0
            },
            noCreditsPopup: false,
            btns: [
                {title: 'Cancel', event: 'deleteCampaign', class: 'red-button', icon: 'fa-times'},
                {title: 'Save Drafts', event: 'saveDraftTrue', class: 'light-blue-btn', icon: 'fa-pencil-square-o'},
                {title: 'Send Test', event: 'openPreviewPopup', class: 'light-blue-btn',},
                {title: 'Launch', event: 'saveDraftFalse', class: 'blue-btn', icon_after: 'fa-paper-plane'},
            ]
        }
    },
    computed: {
        ...mapState(['platform']),
        isEdit() {
            return this.title.toLowerCase() === 'edit'
        },
        countOfMessages(){
            const INDENT_BETWEEN_BLOCKS_AND_UNSUBSCRIBE_LINK_LENGTH = '0123456789123456'
            return  new SegmentedMessage(this.data.body_text + this.data.unsubscribe_text + INDENT_BETWEEN_BLOCKS_AND_UNSUBSCRIBE_LINK_LENGTH).segmentsCount
        }
    },
    async created () {
        await this.getCampaign();
        this.loading = false
        if(this.platform === 'wix') {
            this.disabledLaunch = true
            await this.getShopBalance()
            this.disabledLaunch = false
        }
    },
    methods: {
        async submit(isDraft = false, useExistingCredits = true) {
            const result = await this.$refs.form.validate();
            let valid    = await this.$refs.form;
            if(result) {
                this.save(isDraft, useExistingCredits)
                setTimeout(() => {
                    this.$refs.form.reset()
                }, 2000)
            }
            else this.getFormErrors(valid.errors)
        },
        openPreviewPopup() {
            if(!this.previewPopup) this.showAlertText = this.checkEditedItems(this.edited)
            this.previewPopup = !this.previewPopup
        },
        checkChanged(key) {
            const data = this.trackСhange(this.oldData, this.data, key)
            if(data.key) this.edited[data.key] = data.value
        },
        async save(isDraft = false, useExistingCredits = true) {
            if ($cookies.get('platform') === 'wix' && this.balance.smsBalance < this.priceData.approximate_sms_campaign_cost && useExistingCredits && !isDraft) {
                this.noCreditsPopup = true;
                isDraft             = true;
                return;
            }

            this.data.is_draft      = isDraft;
            this.data.user_timezone = this.$moment.tz.guess()
            let id = this.$route.params.id

            await this.update(id ,this.data)

            if(isDraft) this.getCampaign()



            this.$notify({
                type: 'success',
                title: 'Saved'
            });

            if(!isDraft) this.$router.push('/sms/campaigns')
        },
        async getCampaign() {
            const { data } = await this.getCampaignsById(this.$route.params.id);

            const item = data.data
            item.unsubscribe_confirmation = 'You have been successfully unsubscribed'

            item.schedule_datetime = this.$moment(item.schedule_datetime).format('YYYY-MM-DD HH:mm')
            this.data  = data.data
            this.oldData = JSON.parse(JSON.stringify(this.data))
            this.edited = this.createEditedObj(this.oldData)

            if(this.showAlertText) this.showAlertText = false
        },
        setPriceData(data) {
            this.priceData = data;
        },
        async getShopBalance() {
            this.balance = await this.getBalance();
        },
        async cancel() {
            if(this.$route.params.first) {
                try {
                    const data = await this.delete(this.$route.params.id)
                    if(!data) return
                } catch(err) {
                    return
                }
            }
            this.$router.push('/sms/campaigns/');
        },
        async sendPreview(item) {
            if(item.disabledCountries && item.disabledCountries.length) {
                this.sendData = item
                this.showDisabledCountriesModal = true
                this.previewPopup = false
                return
            }
            try {
                await this.sendPreviewSms(this.data.id, {
                    sms: item.smsValue,
                    averagePrice: item.averagePrice,
                    campaignId: this.data.id
                })
                this.previewPopup = false
                this.$notify({
                    type: 'success',
                    title: 'Sent'
                })
                this.closeDisabledCountriesModal()
            } catch (error) {
                console.log(error)
                this.$refs.test.stopLoading()
                this.$refs.disabled_countries_modal.stopLoading()
            }
        },
         closeDisabledCountriesModal() {
            this.sendData = false
            this.showDisabledCountriesModal = false
        }
    }
}
</script>


<style lang="scss" scoped>
.broadcast-form-header {
    margin-top: 40px;
    margin-bottom: 40px;
}

.campaigns-title {
    font-size: 28px;
    font-weight: bold;
    @media screen and (max-width: 765px) {
        margin-bottom: 20px;
    }
}

.light-blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}

.red-button {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}

.blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}

.no-credit-popup {
    padding: 10px 10px;
}

.close-container {
    display: flex;
    justify-content: flex-end;

    .btn {
        margin: 10px 10px 0 0;
    }
}

.close-button {
    width: 28px;
    transform: rotate(45deg);
}
@media(max-width: 770px) {
    .content {
        flex-direction: column;
    }
}
.popup-body-container {
    display: flex;
    justify-content: center;
    align-items: center;
}
.send-action {
    &-container {
        display: flex;
        flex-direction: column;
        width: 100%;
    }
    &__actions {
        margin-top: 1rem;
        display: flex;
        justify-content: flex-end;
        span {
            width: calc(100% - 145px);
            display: block;
            margin-right: auto;opacity: 0.8;
        }
    }

    .blue-btn {
        margin-left: 5px;
        padding: 0pc 20px;
    }
}
.edit__top {
    margin-top: 25px;
}
</style>
